%define major 3
%define libname %mklibname sasl2_ %{major}
%define devname %mklibname sasl2 -d

%define sasl2_db_filename /var/lib/sasl2/sasl.db

%define KRB5 1
%define MYSQL 1
%define SRP 1
%define PGSQL 1
%define SQLITE3 1
%define LDAP 1
%define SRPSTR enabled
%define MYSQLSTR enabled
%define PGSQLSTR enabled
%define SQLITE3STR enabled
%define LDAPSTR enabled

%{?_with_krb5: %{expand: %%global KRB5 1}}
%{?_without_krb5: %{expand: %%global KRB5 0}}
%{?_with_srp: %{expand: %%global SRP 1}}
%{?_without_srp: %{expand: %%global SRP 0}}
%{?_with_mysql: %{expand: %%global MYSQL 1}}
%{?_without_mysql: %{expand: %%global MYSQL 0}}
%{?_with_pgsql: %{expand: %%global PGSQL 1}}
%{?_without_pgsql: %{expand: %%global PGSQL 0}}
%{?_with_sqlite3: %{expand: %%global SQLITE3 1}}
%{?_without_sqlite3: %{expand: %%global SQLITE3 0}}
%{?_with_ldap: %{expand: %%global LDAP 1}}
%{?_without_ldap: %{expand: %%global LDAP 0}}

%{?_with_srp: %{expand: %%global SRPSTR enabled}}
%{?_without_srp: %{expand: %%global SRPSTR disabled}}
%{?_with_mysql: %{expand: %%global MYSQLSTR enabled}}
%{?_without_mysql: %{expand: %%global MYSQLSTR disabled}}
%{?_with_pgsql: %{expand: %%global PGSQLSTR enabled}}
%{?_without_pgsql: %{expand: %%global PGSQLSTR disabled}}
%{?_with_sqlite3: %{expand: %%global SQLITE3STR enabled}}
%{?_without_sqlite3: %{expand: %%global SQLITE3STR disabled}}
%{?_with_ldap: %{expand: %%global LDAPSTR enabled}}
%{?_without_ldap: %{expand: %%global LDAPSTR disabled}}

# bootstrapping overrides the above LDAP defines
%{?bootstrap: %{expand: %%global LDAP 0}}
%{?bootstrap: %{expand: %%global LDAPSTR disabled}}

Summary:	The Simple Authentication and Security Layer
Name:		cyrus-sasl
Version:	2.1.27
Release:	%mkrel 4
License:	BSD-style
Group:		System/Libraries
URL:		https://www.cyrusimap.org/sasl/
Source0:	https://www.cyrusimap.org/releases/%{name}-%{version}.tar.xz
Source2:	saslauthd.init
Source3:	saslauthd.sysconfig
Source4:	service.conf.example
Source7:	sasl-mechlist.c
Patch0:		cyrus-sasl-doc.patch
Patch11:	cyrus-sasl-2.1.25-no_rpath.diff
Patch23:	cyrus-sasl-2.1.23-man.patch
Patch24:	cyrus-sasl-2.1.21-sizes.patch
Patch28:	cyrus-sasl-2.1.25-keytab.diff
Patch49:	cyrus-sasl-2.1.26-md5global.patch

Patch101:	cyrus-sasl-split-sql.patch
Patch103:	cyrus-sasl-parallel-make.patch
Patch104:	cyrus-sasl-ac-libs.patch
Patch107:	cyrus-sasl-2.1.26-no_version-info_for_plugins.diff

Recommends:   %{_lib}sasl2-plug-plain
Recommends:   %{_lib}sasl2-plug-login
Recommends:   %{_lib}sasl2-plug-anonymous
Requires:	%{libname} >= %{version}
Requires(post):	rpm-helper
Requires(preun): rpm-helper
BuildRequires:	db-devel
BuildRequires:	pam-devel
BuildRequires:	pkgconfig(openssl)
BuildRequires:	groff-for-man
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libtool
# 1.4.x is thread safe, which means we can disable sasl mutexes (see ./configure
# further below)
%if %{KRB5}
BuildRequires:	pkgconfig(krb5) >= 1.4.1
%endif
%if %{MYSQL}
BuildRequires:	mysql-devel
%endif
%if %{PGSQL}
BuildRequires:	postgresql-devel
%endif
%if %{SQLITE3}
BuildRequires:	pkgconfig(sqlite3)
%endif
%if %{LDAP}
BuildRequires:	openldap-devel
%endif

%description
SASL is the Simple Authentication and Security Layer,
a method for adding authentication support to connection-based protocols.
To use SASL, a protocol includes a command for identifying and authenticating
a user to a server and for optionally negotiating protection of subsequent
protocol interactions. If its use is negotiated, a security layer is inserted
between the protocol and the connection.
To actually use SASL you must install at least one of the %{_lib}sasl2-plug-XXXX
authentication plugin, such as %{_lib}sasl2-plug-plain.
The SQL auxprop plugin can be rebuild with different database backends:
	--with srp	SRP support	(%{SRPSTR})
	--with mysql	MySQL support	(%{MYSQLSTR})
	--with pgsql	Postgres SQL support	(%{PGSQLSTR})
	--with sqlite3	SQLite v3 support	(%{SQLITE3STR})

%package -n	%{libname}
Summary:	Libraries for SASL a the Simple Authentication and Security Layer
Group:		System/Libraries
Obsoletes:	%{_lib}sasl3 

%description -n	%{libname}
SASL is the Simple Authentication and Security Layer,
a method for adding authentication support to connection-based protocols.
To use SASL, a protocol includes a command for identifying and authenticating
a user to a server and for optionally negotiating protection of subsequent
protocol interactions. If its use is negotiated, a security layer is inserted
between the protocol and the connection.

%package -n	%{devname}
Summary:	Libraries for SASL a the Simple Authentication and Security Layer
Group:		Development/Libraries
Provides:	libsasl-devel = %{version}-%{release}
Provides:	libsasl2-devel = %{version}-%{release}
Provides:	cyrus-sasl-devel = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}
Requires:	pam-devel
Obsoletes:	%{_lib}sasl3-devel

%description -n	%{devname}
SASL is the Simple Authentication and Security Layer,
a method for adding authentication support to connection-based protocols.
To use SASL, a protocol includes a command for identifying and authenticating
a user to a server and for optionally negotiating protection of subsequent
protocol interactions. If its use is negotiated, a security layer is inserted
between the protocol and the connection.

%package -n	%{_lib}sasl2-plug-anonymous
Summary:	SASL ANONYMOUS mechanism plugin
Group:		System/Libraries
Requires:	%{libname} >= %{version}
Provides:	sasl-plug-anonymous
Obsoletes:	%{_lib}sasl3-plug-anonymous 

%description -n	%{_lib}sasl2-plug-anonymous
This plugin implements the SASL ANONYMOUS mechanism,
used for anonymous authentication.

%package -n	%{_lib}sasl2-plug-crammd5
Summary:	SASL CRAM-MD5 mechanism plugin
Group:		System/Libraries
Requires:	%{libname} >= %{version}
Provides:	sasl-plug-crammd5
Obsoletes:	%{_lib}sasl3-plug-crammd5 

%description -n	%{_lib}sasl2-plug-crammd5
This plugin implements the SASL CRAM-MD5 mechanism.
CRAM-MD5 is the mandatory-to-implement authentication mechanism for a
number of protocols; it uses MD5 with a challenge/response system to
authenticate the user.

%package -n	%{_lib}sasl2-plug-digestmd5
Summary:	SASL DIGEST-MD5 mechanism plugin
Group:		System/Libraries
Requires:	%{libname} >= %{version}
Provides:	sasl-plug-digestmd5
Obsoletes:	%{_lib}sasl3-plug-digestmd5 

%description -n	%{_lib}sasl2-plug-digestmd5
This plugin implements the latest draft of the SASL DIGEST-MD5
mechanism.  Although not yet finalized, this is likely to become the
new mandatory-to-implement authentication system in all new protocols.
It's based on the digest md5 authentication system designed for HTTP.

%package -n	%{_lib}sasl2-plug-plain
Summary:	SASL PLAIN mechanism plugin
Group:		System/Libraries
Requires:	%{libname} >= %{version}
Provides:	sasl-plug-plain
Obsoletes:	%{_lib}sasl3-plug-plain 

%description -n	%{_lib}sasl2-plug-plain
This plugin implements the SASL PLAIN mechanism.  Although insecure,
PLAIN is useful for transitioning to new security mechanisms, as this
is the only mechanism which gives the server a copy of the user's
password.

%package -n 	%{_lib}sasl2-plug-scram
Summary:	SASL SCRAM-SHA-1 mechanism plugin
Group:		System/Libraries
Requires:	%{libname} = %{version}
Provides:	sasl-plug-scram
Obsoletes:	%{_lib}sasl3-plug-scram 

%description -n	%{_lib}sasl2-plug-scram
This plugin implements the SASL SCRAM-SHA-1 SASL plugin mechanism.

%package -n	%{_lib}sasl2-plug-login
Summary:	SASL LOGIN mechanism plugin
Group:		System/Libraries
Requires:	%{libname} >= %{version}
Provides:	sasl-plug-login
Obsoletes:	%{_lib}sasl3-plug-login 

%description -n	%{_lib}sasl2-plug-login
This plugin implements the SASL LOGIN mechanism.
THIS PLUGIN IS DEPRECATED, is maintained only for compatibility reasons
and will be dropped soon.
Please use the plain plugin instead.

%if %{KRB5}
%package -n	%{_lib}sasl2-plug-gssapi
Summary:	SASL GSSAPI mechanism plugin
Group:		System/Libraries
Requires:	%{libname} >= %{version}
Requires:	krb5-libs
Provides:	sasl-plug-gssapi
Obsoletes:	%{_lib}sasl3-plug-gssapi 

%description -n	%{_lib}sasl2-plug-gssapi
This plugin implements the SASL GSSAPI (kerberos 5)mechanism.
%endif

%package -n	%{_lib}sasl2-plug-otp
Summary:	SASL OTP mechanism plugin
Group:		System/Libraries
Requires:	%{libname} >= %{version}
Provides:	sasl-plug-otp
Obsoletes:	%{_lib}sasl3-plug-otp 

%description -n	%{_lib}sasl2-plug-otp
This plugin implements the SASL OTP mechanism.

%package -n	%{_lib}sasl2-plug-sasldb
Summary:	SASL sasldb auxprop plugin
Group:		System/Libraries
# Requirement for %%{name} is due to dbconverter-2 being
# potentially called in %%post
Requires(post):	%{name} >= %{version}
# That requirement has to be here (in "Requires") also
# (http://archives.mandrivalinux.com/cooker/2005-06/msg00109.php)
Requires:	%{libname} >= %{version}, %{name} >= %{version}
Provides:	sasl-plug-sasldb
Obsoletes:	%{_lib}sasl3-plug-sasldb 

%description -n	%{_lib}sasl2-plug-sasldb
This package provides the SASL sasldb auxprop plugin, which stores secrets
in a Berkeley database file.

%if %{SRP}
%package -n	%{_lib}sasl2-plug-srp
Summary:	SASL srp mechanism plugin
Group:		System/Libraries
Requires:	%{libname} >= %{version}
Provides:	sasl-plug-srp
Obsoletes:	%{_lib}sasl3-plug-srp 

%description -n	%{_lib}sasl2-plug-srp
This plugin implements the srp  mechanism.
%endif

%package -n	%{_lib}sasl2-plug-ntlm
Summary:	SASL ntlm authentication plugin
Group:		System/Libraries
Requires:	%{libname} >= %{version}
Provides:	sasl-plug-ntlm
Obsoletes:	%{_lib}sasl3-plug-ntlm 

%description -n	%{_lib}sasl2-plug-ntlm
This plugin implements the (unsupported) ntlm authentication.

%if %{MYSQL}
%package -n	%{_lib}sasl2-plug-mysql
Summary:	SASL MySQL plugin
Group:		System/Libraries
Requires:	%{libname} >= %{version}
Provides:	sasl-plug-sql
Obsoletes:	%{_lib}sasl3-plug-mysql 

%description -n	%{_lib}sasl2-plug-mysql
This plugin implements the MySQL authentication method
%endif

%if %{PGSQL}
%package -n	%{_lib}sasl2-plug-pgsql
Summary:	SASL PostgreSQL plugin
Group:		System/Libraries
Requires:	%{libname} >= %{version}
Provides:	sasl-plug-sql
Obsoletes:	%{_lib}sasl3-plug-pgsql 

%description -n	%{_lib}sasl2-plug-pgsql
This plugin implements the PostgreSQL authentication method
%endif

%if %{SQLITE3}
%package -n	%{_lib}sasl2-plug-sqlite3
Summary:	SASL SQLite v3 plugin
Group:		System/Libraries
Requires:	%{libname} >= %{version}
Obsoletes:  lib64sasl2-plug-sql
Provides:   lib64sasl2-plug-sql = %version-%release
Provides:	sasl-plug-sql
Obsoletes:	%{_lib}sasl3-plug-sqlite3 

%description -n	%{_lib}sasl2-plug-sqlite3
This plugin implements the SQLite v3 authentication method
%endif

%if %{LDAP}
%package -n	%{_lib}sasl2-plug-ldapdb
Summary:	SASL ldapdb auxprop plugin
Group:		System/Libraries
Requires:	%{libname} >= %{version}
Provides:	sasl-plug-ldapdb
Obsoletes:	%{_lib}sasl3-plug-ldapdb 

%description -n	%{_lib}sasl2-plug-ldapdb
This plugin implements the LDAP auxprop authentication method.
%endif

%prep
%setup -q
install -m 0644 %{SOURCE4} .
%patch0 -p1 -b .sasldoc~

%patch11 -p0 -b .no_rpath~
%patch23 -p1 -b .man~
%patch24 -p1 -b .sizes
%patch49 -p1 -b .md5global.h

%patch101 -p1
%patch103 -p1
%patch104 -p1
%patch107 -p0

cp %{SOURCE7} sasl-mechlist.c

%build
autoreconf -vfi
%serverbuild

%configure2_5x 	\
    --disable-static \
    --with-plugindir=%{_libdir}/sasl2 \
    --with-configdir=%{_sysconfdir}/sasl2:%{_libdir}/sasl2 \
    --disable-krb4 \
    --enable-login \
    --enable-alwaystrue \
%if %{SRP}
    --enable-srp --enable-srp-setpass \
%else
    --without-srp --without-srp-srp-setpass \
%endif
    --enable-ntlm \
    --enable-db4 \
    --enable-gssapi \
    --disable-gss_mutexes \
%if %{MYSQL}
    --enable-sql --with-mysql=%{_libdir} \
%else
    --without-mysql \
%endif
%if %{PGSQL}
    --enable-sql --with-pgsql=%{_libdir} \
%else
    --without-pgsql \
%endif
%if %{SQLITE3}
    --enable-sql --with-sqlite3=%{_prefix} \
%else
    --without-sqlite \
%endif
%if %{LDAP}
    --with-ldap=%{_prefix} --enable-ldapdb \
%endif
    --with-dbpath=%{sasl2_db_filename} \
    --with-bdb=db \
    --with-saslauthd=/run/saslauthd \
    --with-authdaemond=/run/authdaemon.courier-imap/socket \
    --with-devrandom=/dev/urandom

%make_build
%make_build -C saslauthd testsaslauthd
%make_build -C sample

install saslauthd/LDAP_SASLAUTHD README.ldap

# Build a small program to list the available mechanisms, because I need it.
pushd lib
    ../libtool --mode=link %{__cc} -o sasl2-shared-mechlist \
	-I../include $CFLAGS ../sasl-mechlist.c $LDFLAGS ./libsasl2.la
popd

%install
mkdir -p %{buildroot}/var/lib/sasl2
mkdir -p %{buildroot}%{_sysconfdir}/sasl2

%makeinstall_std

mkdir -p %{buildroot}%{_initrddir}
install -m755 %{SOURCE2} -D %{buildroot}%{_initrddir}/saslauthd
install -m 644 %{SOURCE3} -D %{buildroot}%{_sysconfdir}/sysconfig/saslauthd

# we don't need these
find %{buildroot} -name *.la -delete

# dbconverter-2 isn't installed by make install

cd utils
/bin/sh ../libtool --mode=install /usr/bin/install -c dbconverter-2 \
  %{buildroot}/%{_sbindir}/dbconverter-2

cd ..
cp saslauthd/testsaslauthd %{buildroot}%{_sbindir}
cd sample
/bin/sh ../libtool --mode=install /usr/bin/install -c client \
  %{buildroot}/%{_sbindir}/sasl-sample-client
/bin/sh ../libtool --mode=install /usr/bin/install -c server \
  %{buildroot}/%{_sbindir}/sasl-sample-server
cd ..

# multiarch policy
%multiarch_includes %{buildroot}%{_includedir}/sasl/md5global.h

# quick README about the sasl.db file permissions
cat > README.Mageia.sasldb <<EOF
A system group called "sasl" is created and an empty %{sasl2_db_filename}
file with the following permissions: mode 0640, ownership root:sasl is
created by default.

If the %{sasl2_db_filename} file already exists, it is not changed
in any way.

It is recommended that administrators keep these permissions and add
application users to the "sasl" group if access to this database is needed.

For example, to permit the Postfix SMTP to authenticate users via the sasldb
auxprop plugin, add the "postfix" user to the "sasl" group and read the
"SMTP Authentication" section of the README.mga documentation file for
details regarding Postfix's chroot setup.

For other applications in general, just add their user to the "sasl" group.
EOF

# This is just to "close" vim's syntax misinterpretation.. ;p

# Provide an easy way to query the list of available mechanisms.
./libtool --mode=install install -m0755 lib/sasl2-shared-mechlist %{buildroot}%{_sbindir}/

%pre -n %{_lib}sasl2-plug-sasldb
%_pre_groupadd sasl

%post -n %{_lib}sasl2-plug-sasldb
#convert old sasldb
# XXX - what about berkeley db versions? - andreas
if [ -f /var/lib/sasl/sasl.db -a ! -f %{sasl2_db_filename} ]; then
	echo "" | /usr/sbin/dbconverter-2 /var/lib/sasl/sasl.db %{sasl2_db_filename}
	if [ -f %{sasl2_db_filename} ]; then
		# conversion was successfull
		chmod 0640 %{sasl2_db_filename}
		chown root:sasl %{sasl2_db_filename}
	fi
fi
if [ -f /var/lib/sasl/sasl.db.rpmsave -a ! -f %{sasl2_db_filename} ]; then
	echo "" | /usr/sbin/dbconverter-2 /var/lib/sasl/sasl.db.rpmsave %{sasl2_db_filename}
	if [ -f %{sasl2_db_filename} ]; then
		# conversion was successfull
		chmod 0640 %{sasl2_db_filename}
		chown root:sasl %{sasl2_db_filename}
	fi
fi
if [ ! -f %{sasl2_db_filename} ]; then
	# the file was never created before nor converted from sasl1
	touch %{sasl2_db_filename}
	chmod 0640 %{sasl2_db_filename}
	chown root:sasl %{sasl2_db_filename}
fi

%post
%_post_service saslauthd

%preun
%_preun_service saslauthd

%files
%doc COPYING AUTHORS INSTALL ChangeLog
%doc doc/html/
%doc service.conf.example
%dir /var/lib/sasl2
%{_initrddir}/saslauthd
%dir %{_sysconfdir}/sasl2
%config(noreplace) %{_sysconfdir}/sysconfig/saslauthd
%{_sbindir}/dbconverter-2
%{_sbindir}/pluginviewer
%{_sbindir}/sasl-sample-client
%{_sbindir}/sasl-sample-server
%{_sbindir}/saslauthd
%{_sbindir}/sasldblistusers2
%{_sbindir}/saslpasswd2
%{_sbindir}/testsaslauthd
%{_mandir}/man8/*

%files -n %{libname}
%dir %{_libdir}/sasl2
%{_libdir}/libsasl*.so.%{major}*

%files -n %{_lib}sasl2-plug-anonymous
%{_libdir}/sasl2/libanonymous.so

%files -n %{_lib}sasl2-plug-otp
%{_libdir}/sasl2/libotp.so

%files -n %{_lib}sasl2-plug-scram
%{_libdir}/sasl2/libscram.so

%files -n %{_lib}sasl2-plug-crammd5
%{_libdir}/sasl2/libcrammd5.so

%files -n %{_lib}sasl2-plug-sasldb
%doc README.Mageia.sasldb
%{_libdir}/sasl2/libsasldb.so

%if %{KRB5}
%files -n %{_lib}sasl2-plug-gssapi
%{_libdir}/sasl2/libgs2.so
%{_libdir}/sasl2/libgssapiv2.so
%endif

%files -n %{_lib}sasl2-plug-digestmd5
%{_libdir}/sasl2/libdigestmd5.so

%files -n %{_lib}sasl2-plug-plain
%{_libdir}/sasl2/libplain.so

%files -n %{_lib}sasl2-plug-login
%{_libdir}/sasl2/liblogin.so

%if %{SRP}
%files -n %{_lib}sasl2-plug-srp
%{_libdir}/sasl2/libsrp.so
%endif

%files -n %{_lib}sasl2-plug-ntlm
%{_libdir}/sasl2/libntlm.so

%if %{MYSQL}
%files -n %{_lib}sasl2-plug-mysql
%{_libdir}/sasl2/libmysql.so
%endif

%if %{PGSQL}
%files -n %{_lib}sasl2-plug-pgsql
%{_libdir}/sasl2/libpgsql.so
%endif

%if %{SQLITE3}
%files -n %{_lib}sasl2-plug-sqlite3
%{_libdir}/sasl2/libsqlite3.so
%endif

%if %{LDAP}
%files -n %{_lib}sasl2-plug-ldapdb
%{_libdir}/sasl2/libldapdb.so
%endif

%files -n %{devname}
%{_sbindir}/sasl2-shared-mechlist
%{_includedir}/sasl
%{multiarch_includedir}/sasl/md5global.h
%{_libdir}/*.*so
%{_libdir}/pkgconfig/*.pc
%{_mandir}/man3/*


%changelog
* Mon Dec 02 2019 tex - 2.1.27-4pclos2019
- rebuild against updates

* Fri Jan 18 2019 tex - 2.1.27-3pclos2019
- fix permission on init file

* Wed Jan 16 2019 tex - 2.1.27-2pclos2019
- rebuild against updates

